<?php

class pi_diagram {
	public $label;
	public $size;
	public $rowlabel=array();
	public $rowdata=array();
	function __construct( $overide_label=false,$overide_size=false ) {
                $this->label="Ueberschrift";
                $this->size="50%";
                if ($overide_label) {
                        $this->label=$overide_label;
                }
                if ($overide_size) {
                        $this->size=$overide_size;
                }
        }
	function set_label($label_in) {
		$this->label=$label_in;
	}
	function set_size($size_in) {
		$this->size=$size_in;
	}
	function add_rowlabel($rowlabel_in) {
		$this->rowlabel[] = $rowlabel_in;
	}
	function add_rowdata($rowdata_in) {
		$this->rowdata[]=$rowdata_in;
	}

	function render_diagram() {
		$ID=md5($this->label);
		$output = "<div id=\"canvas-holder\" style=\"width:" . $this->size . "\"><canvas id=\"chart-area-".$ID."\"></canvas></div>\n";
		$output .= "<script>\n";
		$output .= "var datas = " . json_encode($this->rowdata) . ";\n";
		$output .= "var lables = " . json_encode($this->rowlabel) . ";\n";
		#$output .= "var datas = [10,20,30];\n";
		#$output .= "var lables =  [ 'LG', 'LP', 'LGA' ];\n";
		$output .= "var config = {\n";
		$output .= "  type: 'doughnut',\n";
		$output .= "  data: { datasets:[{\n";
		$output .= "    data: datas,\n";
		$output .= "    backgroundColor: [ 'rgba(255,99,132,0.9)', 'rgba(50,255,132,0.9)', 'rgba(50,99,255,0.9)', 'rgba(50,99,90,0.9)','rgba(255,99,132,0.4)', 'rgba(50,255,132,0.4)', 'rgba(50,99,255,0.4)', 'rgba(50,99,90,0.4)', 'rgba(222,99,199,0.9)', 'rgba(50,222,199,0.9)', 'rgba(50,66,222,0.9)', 'rgba(99,66,99,0.9)','rgba(222,99,199,0.4)', 'rgba(50,222,199,0.4)', 'rgba(50,66,222,0.4)', 'rgba(99,66,99,0.4)' ],\n";
		$output .= "    borderColor: [ 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)','rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)','rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)','rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)' ],\n";
		$output .= "    }],\n";
		$output .= "    labels: lables,\n";
		$output .= "  },\n";
		$output .= "  options: { responsive: true,legend: {position: 'left'}, title: { display: true, text: '" . $this->label . "' },";
		$output .= "          animation: { animateScale: true, animateRotate: true }, cutoutPercentage: 30 }\n";
		$output .= "  };\n";
		$output .= "  window.onload = function() {\n";
		$output .= "  var ctx = document.getElementById('chart-area-".$ID."').getContext('2d');\n";
		$output .= "  window.myDoughnut = new Chart(ctx, config);\n";
		$output .= "};\n";
		$output .= "</script>\n";

		return $output;
	}
}

class bar_diagram {
	public $label;
	public $size;
	public $rowlabel=array();
	public $rowdata=array();
	function __construct( $overide_label=false,$overide_size=false ) {
                $this->label="Ueberschrift";
                $this->size="50%";
                if ($overide_label) {
                        $this->label=$overide_label;
                }
                if ($overide_size) {
                        $this->size=$overide_size;
                }
        }
	function set_label($label_in) {
		$this->label=$label_in;
	}
	function set_size($size_in) {
		$this->size=$size_in;
	}
	function add_rowlabel($rowlabel_in) {
		$this->rowlabel[] = $rowlabel_in;
	}
	function add_rowdata($rowdata_in) {
		$this->rowdata[]=$rowdata_in;
	}

	function render_diagram() {
		$ID=md5($this->label);
		$output = "<div id=\"canvas-holder\" style=\"background-color: white; width:" . $this->size . "\"><canvas id=\"chart-area-".$ID."\"></canvas></div>\n";
		$output .= "<script>\n";
		$output .= "var datas = " . json_encode($this->rowdata) . ";\n";
		$output .= "var lables = " . json_encode($this->rowlabel) . ";\n";
		#$output .= "var datas = [10,20,30];\n";
		#$output .= "var lables =  [ 'LG', 'LP', 'LGA' ];\n";
		$output .= "var config = {\n";
		$output .= "  type: 'horizontalBar',\n";
		$output .= "  data: { datasets:[{\n";
		$output .= "    data: datas,\n";
		$output .= "    backgroundColor: [ 'rgba(255,99,132,0.9)', 'rgba(50,255,132,0.9)', 'rgba(50,99,255,0.9)', 'rgba(50,99,90,0.9)','rgba(255,99,132,0.4)', 'rgba(50,255,132,0.4)', 'rgba(50,99,255,0.4)', 'rgba(50,99,90,0.4)', 'rgba(222,99,199,0.9)', 'rgba(50,222,199,0.9)', 'rgba(50,66,222,0.9)', 'rgba(99,66,99,0.9)','rgba(222,99,199,0.4)', 'rgba(50,222,199,0.4)', 'rgba(50,66,222,0.4)', 'rgba(99,66,99,0.4)' ],\n";
		$output .= "    borderColor: [ 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)','rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)','rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)','rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)', 'rgba(5,5,5,0.2)' ],\n";
		$output .= "    }],\n";
		$output .= "    labels: lables,\n";
		$output .= "  },\n";
		$output .= "  options: { responsive: true, legend: {display: false}, title: { display: true, text: '" . $this->label . "' },";
		$output .= "          animation: { animateScale: true, animateRotate: true } }\n";
		$output .= "  };\n";
		$output .= "  window.onload = function() {\n";
		$output .= "  var ctx = document.getElementById('chart-area-".$ID."').getContext('2d');\n";
		$output .= "  window.myBar = new Chart(ctx, config);\n";
		$output .= "};\n";
		$output .= "</script>\n";

		return $output;
	}
}

?>
