<?php 
# BASIC USAGE
#require('config.inc.php');

# Fire up an instance of the table class
#

function create_teiln_hash ()
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB,$TeilnHashTag,$TeilnHashKlassen,$KlassenSortID;
	$TeilnHashTag=array();
	$mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
	// Check connection
	if (mysqli_connect_errno())
	{
	echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
        $SQL="SELECT Nummer, Nachname, Vorname, VereinsID, Verein, Klasse, ErsteScheibe from Teilnehmer ORDER BY ErsteScheibe";
	$result = mysqli_query($mysqlcon,$SQL);
	while($row = mysqli_fetch_array($result))
	{      
		$Datum_eng=preg_replace("/ .*/", "", $row['ErsteScheibe']);
		$Datum=preg_replace("/(....)-(..)-(..)/","$3.$2.$1",$Datum_eng);
		$Klasse=$row['Klasse']; if ($Klasse == "") { $Klasse="99"; }
		$KID=$KlassenSortID[$Klasse]; 
		#echo "Klasse: $Klasse ($KlassenID)<br>\n";
		if (isset($TeilnHashTag[$Datum])) {
			$TeilnHashTag[$Datum]=$TeilnHashTag[$Datum]+1;
		} else {
			$TeilnHashTag[$Datum]=1;
		}

		$TeilnHashTagKlasse[$Datum][$Klasse]=$TeilnHashTag[$Datum][$Klasse]+1;
		if (isset($TeilnHashKlassen[$KID])) {
			$TeilnHashKlassen[$KID]=$TeilnHashKlassen[$KID]+1;
		} else {
			$TeilnHashKlassen[$KID]=1;
		}
		$TeilnHashKlassenTag[$KID][$Datum]=$TeilnHashKlassen[$KID][$Datum]+1;
		$Nummer=$row['Nummer'];
		#echo "Add Teilnehmer $Nummer $Datum $Klasse $KID<br>\n";
	}
	ksort($TeilnHashKlassen,SORT_NUMERIC);

}

function get_anzahl_scheiben()
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB,$KlassenSortID;
	$TeilnHashTag=array();
	$mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
	// Check connection
	if (mysqli_connect_errno())
	{
	echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
        $SQL="SELECT count(*) from Scheiben";
	$result = mysqli_query($mysqlcon,$SQL);
	$row = mysqli_fetch_array($result);
	return $row['count(*)'];

}

function show_teilnehmer_day($do_print)
{
	global $TeilnHashTag,$TeilnHashKlassen;
	$valuesum = 0;
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr); 
	# Define some headings
	$headings = array("Tag", "Teilnehmer neu", "Teilnehmer gesamt");

	# Add them to the class using the headings() function
	$table->headings($headings);

	foreach ( $TeilnHashTag as $key => $value )
	{      
		$Datum=$key;
		$valuesum = $valuesum + $value;
		$table->addRow(array($Datum,$value,$valuesum));
	}

	echo '<p align="center" class="font12p"> ' . "Teilnehmer nach Tagen" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();

}


function show_teilnehmer_klassen($do_print)
{
	global $TeilnHashTag,$TeilnHashKlassen,$InvKlassenSortID;
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr); 
	# Define some headings
	$headings = array("Klasse", "Teilnehmer");

	# Add them to the class using the headings() function
	$table->headings($headings);

	foreach ( $TeilnHashKlassen as $key => $value )
	{      
		$Klasse=$InvKlassenSortID[$key];
		$table->addRow(array($Klasse,$value));
	}

	echo '<p align="center" class="font12p"> ' . "Teilnehmer nach Klassen" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();

}

function show_Disziplin_anz($do_print)
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB;
        $mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
        // Check connection
        if (mysqli_connect_errno())
        {
        echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr);
	 # Define some headings
        $headings = array("Disziplin", "Scheiben");
	$table->headings($headings);
        $SQL="select Disziplin, count(*) from Scheiben group by Disziplin";
        $result = mysqli_query($mysqlcon,$SQL);
        while($row = mysqli_fetch_array($result))
	{
		$table->addRow(array($row['Disziplin'], $row['count(*)']));
        }
	echo '<p align="center" class="font12p"> ' . "Scheibenanzahl nach Disziplin" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();
}

function show_teilnehmer_Disziplin($do_print)
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB;
        $mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
        // Check connection
        if (mysqli_connect_errno())
        {
        echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr);
	 # Define some headings
        $headings = array("Disziplin", "Teilnehmer");
	$table->headings($headings);
        $SQL="select count(distinct(StartNr)) as anz,disziplin from Scheiben group by Disziplin";
        $result = mysqli_query($mysqlcon,$SQL);
        while($row = mysqli_fetch_array($result))
	{
		$table->addRow(array($row['disziplin'], $row['anz']));
        }
	echo '<p align="center" class="font12p"> ' . "Teilnehmer nach Disziplin" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();
}

function show_teilnehmer_anz_scheiben($do_print)
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB;
        $mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
	$Platz=1;
        // Check connection
        if (mysqli_connect_errno())
        {
        echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr);
	 # Define some headings
        $headings = array("Platz", "Anzahl", "Teilnehmer", "Name", "Verein");
	$table->headings($headings);
        $SQL="select count(*) as anz, StartNr, Nachname, Vorname, Verein from Scheiben group by StartNr order by anz desc limit 15";
        $result = mysqli_query($mysqlcon,$SQL);
        while($row = mysqli_fetch_array($result))
	{
		$table->addRow(array($Platz, $row['anz'], "<A HREF=index.php?TYP=Teilnehmer&ID=".$row['StartNr'].">".$row['StartNr']."</A>", $row['Nachname']." ".$row['Vorname'], $row['Verein']));
		$Platz++;
        }
	echo '<p align="center" class="font12p"> ' . "Teilnehmer mit den meisten Serien" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();
}

function show_vereine_anz_scheiben($do_print)
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB;
	$Platz=1;
        $mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
        // Check connection
        if (mysqli_connect_errno())
        {
        echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr);
	 # Define some headings
        $headings = array("Platz", "Anzahl", "Verein");
	$table->headings($headings);
        $SQL="select count(*) as anz, Verein from Scheiben group by Verein order by anz desc limit 15";
        $result = mysqli_query($mysqlcon,$SQL);
        while($row = mysqli_fetch_array($result))
	{
		$table->addRow(array($Platz, $row['anz'], $row['Verein']));
		$Platz=$Platz+1;
        }
	echo '<p align="center" class="font12p"> ' . "Vereine mit den meisten Serien" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();
}

function show_Disziplin_Klassen_anz($do_print)
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB;
        $mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
        // Check connection
        if (mysqli_connect_errno())
        {
        echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr);
	 # Define some headings
        $headings = array("Disziplin", "Klasse", "Scheiben");
	$table->headings($headings);
        $SQL="select Disziplin, Klasse, count(*) from Scheiben group by Disziplin, Klasse";
        $result = mysqli_query($mysqlcon,$SQL);
        while($row = mysqli_fetch_array($result))
	{
		$table->addRow(array($row['Disziplin'],$row['Klasse'], $row['count(*)']));
        }
	echo '<p align="center" class="font12p"> ' . "Scheibenanzahl nach Disziplin und Klasse" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();
}


function show_scheiben_datum($do_print)
{
	global $MySqlHost,$MySqlUser,$MySqlPw,$MySqlDB;
        $mysqlcon=mysqli_connect("$MySqlHost","$MySqlUser","$MySqlPw","$MySqlDB");
        // Check connection
        if (mysqli_connect_errno())
        {
        echo "Failed to connect to MySQL: " . mysqli_connect_error();
	}
	if ( $do_print == 1) { 
	  $table_attr = array("class"=>"print");
	} else {
	  $table_attr = array("class"=>"result");
	}
	$table = new Table($table_attr);
	 # Define some headings
        $headings = array("Datum", "Scheiben");
	$table->headings($headings);
        $SQL="select DATE_FORMAT(Zeitstempel,'%d.%m.%Y') as Datum, count(*) from Scheiben group by DATE_FORMAT(Zeitstempel,'%d.%m.%Y')";
        $result = mysqli_query($mysqlcon,$SQL);
        while($row = mysqli_fetch_array($result))
	{
		$table->addRow(array($row['Datum'], $row['count(*)']));
        }
	echo '<p align="center" class="font12p"> ' . "Scheibenanzahl nach Datum" . '</p>';
	# To complete the table you need to run the render function
	echo $table->render();
}

?>
