#!/usr/bin/perl -w
use strict;
use lib ".";
use warnings;
use DBI;
use gsConfig;
use gsFunctions;

my ($db1_user, $db1_name, $db1_passwd, $db1_host, $db1_port) = @SSMDB2;
my ($db2_user, $db2_name, $db2_passwd, $db2_host, $db2_port) = @WERTUNGDB;

my $dbh1 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
my $dbh2 = DBI->connect("DBI:mysql:database=$db2_name;host=$db2_host;port=$db2_port", "$db2_user", "$db2_passwd");
my $dbh3 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
my $dbh4 = DBI->connect("DBI:mysql:database=$db2_name;host=$db2_host;port=$db2_port", "$db2_user", "$db2_passwd");
my $dbh5 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
my $dbh6 = DBI->connect("DBI:mysql:database=$db2_name;host=$db2_host;port=$db2_port", "$db2_user", "$db2_passwd");


my $inssql;
my $db2_query;
my $CopyTime;
my $CopyFromTime="";
if ($CopyMode eq "Initial") {
  doLog 2, "Initiere Scheiben, Serien und Treffer";
  $db2_query = $dbh2->prepare("TRUNCATE Scheiben");
  $db2_query->execute() or die $db2_query->err_str;
  $db2_query = $dbh2->prepare("TRUNCATE Serien");
  $db2_query->execute() or die $db2_query->err_str;
  $db2_query = $dbh2->prepare("TRUNCATE Treffer");
  $db2_query->execute() or die $db2_query->err_str;
} else {
  $db2_query = $dbh2->prepare("SELECT Zeit from Einstellungen WHERE Name='LastUpdate'");
  $db2_query->execute() or die $db2_query->err_str;
  ($CopyTime)=$db2_query->fetchrow_array();
  $CopyTime =~ s/ .*//;
  if ($CopyTime eq "") {$CopyTime="2018-01-01";}
  $CopyFromTime=" AND Zeitstempel >= '$CopyTime' ";
}
  

my $SqlListe = "";
my @StarterListen = split(";",$STARTERLISTEN);
foreach my $StarterListe ( @StarterListen ) {
  if ( $SqlListe eq "" ) { $SqlListe = "Starterliste='$StarterListe'"; } else {$SqlListe = "$SqlListe OR Starterliste='$StarterListe'"; }
}
my $selsql="select ScheibenID, StarterlistenID, StartNr, Nachname, Vorname, SportpassID, Disziplin, Klasse, VereinsID, Verein, Mannschaft, Trefferzahl, Totalring, Totalring01, BesterTeiler01, Zeitstempel from Scheiben where $SqlListe $CopyFromTime AND Disziplin NOT LIKE '".$Koenig_excl."'";
my $db1_query = $dbh1->prepare($selsql);
$db1_query->execute() or die $db1_query->err_str;
doLog 2, "Start copy Scheiben";
doLog 3, $selsql;
 
my $db4_query;
my $db6_query;
my $BesterTeilerN01;
my $TeilerN01;
my $Nummer=0;
my $NR=0;
my $NR_Ser=0;
my $NR_Treffer=0;
my $now=getDateTime;
$inssql="INSERT INTO Einstellungen ( Name, Zeit ) VALUES ('LastUpdate', '$now') ON DUPLICATE KEY UPDATE Zeit='$now'";
doLog 4, $inssql;
$db2_query = $dbh2->prepare($inssql);
$db2_query->execute() or die $db2_query->err_str;

while (my ($ScheibenID, $StarterlistenID, $StartNr, $Nachname, $Vorname, $SportpassID, $Disziplin, $Klasse, $VereinsID, $Verein, $Mannschaft, $Trefferzahl, $Totalring, $Totalring01, $BesterTeiler01, $Zeitstempel) = $db1_query->fetchrow_array() ) {
  $Nummer=$StarterlistenID*$SlMultiplikator+$StartNr;
  $BesterTeiler01=$BesterTeiler01/10;
  $Totalring01=$Totalring01/10;
  $Totalring=$Totalring/10;
  $BesterTeilerN01 = $BesterTeiler01;
  #if ( $Disziplin =~ /$LPFaktorString/ ) { $BesterTeilerN01 = $BesterTeilerN01 * $LPFaktor; }
  #if ( $Disziplin =~ /$AuflFaktorString/ ) { $BesterTeilerN01 = $BesterTeilerN01 * $AuflFaktor; }
  if ( defined $TeilerFaktor{$Disziplin} ) { $BesterTeilerN01 = $BesterTeilerN01 * $TeilerFaktor{$Disziplin}; }
  $inssql="INSERT INTO Scheiben (ScheibenID, StartNr, Nachname, Vorname, SportpassID, Disziplin, Klasse, VereinsID, Verein, Mannschaft, Trefferzahl, Totalring, Totalring01, BesterTeiler01, Zeitstempel, BesterTeilerN01) VALUES ('$ScheibenID', '$Nummer', '$Nachname', '$Vorname', '$SportpassID', '$Disziplin', '$Klasse', '$VereinsID', '$Verein', '$Mannschaft', '$Trefferzahl', '$Totalring', '$Totalring01', '$BesterTeiler01', '$Zeitstempel', '$BesterTeilerN01') ON DUPLICATE KEY UPDATE Trefferzahl='$Trefferzahl', Totalring='$Totalring', Totalring01='$Totalring01', BesterTeiler01='$BesterTeiler01', BesterTeilerN01='$BesterTeilerN01'";
  $db2_query = $dbh2->prepare($inssql);
  $db2_query->execute() or die $db2_query->err_str;
  doLog 7, $inssql;

  # Serien kopieren
  my $db3_query = $dbh3->prepare("select Serie, Ring, Ring01 from Serien where ScheibenID = '$ScheibenID'");
  $db3_query->execute() or die $db3_query->err_str;
  while (my ($Serie, $Ring, $Ring01) = $db3_query->fetchrow_array() ) {
    $Ring01=$Ring01/10;
    $inssql="INSERT INTO Serien (ScheibenID, Serie, Ring, Ring01) VALUES ('$ScheibenID','$Serie', '$Ring', '$Ring01') ON DUPLICATE KEY UPDATE Ring='$Ring', Ring01='$Ring01'";    
    $db4_query = $dbh4->prepare($inssql);
    $db4_query->execute() or die $db4_query->err_str;
    doLog 8, $inssql;
    ++$NR_Ser;
  }
  # Treffer kopieren
  my $db5_query = $dbh5->prepare("select Treffer, x, y, Ring, Ring01, Teiler01 from Treffer where ScheibenID = '$ScheibenID'");
  $db5_query->execute() or die $db5_query->err_str;
  while (my ($Treffer, $x, $y, $Ring, $Ring01, $Teiler01) = $db5_query->fetchrow_array() ) {
    $Ring01=$Ring01/10;
    $Teiler01=$Teiler01/10;
    $TeilerN01 = $Teiler01;
    #if ( $Disziplin =~ /$LPFaktorString/ ) { $TeilerN01 = $TeilerN01 * $LPFaktor; }
    #if ( $Disziplin =~ /$AuflFaktorString/ ) { $TeilerN01 = $TeilerN01 * $AuflFaktor; }
    if ( defined $TeilerFaktor{$Disziplin} ) { $TeilerN01 = $TeilerN01 * $TeilerFaktor{$Disziplin}; }
    $inssql="INSERT INTO Treffer (ScheibenID, Treffer, x, y, Ring, Ring01, Teiler01, TeilerN01) VALUES ('$ScheibenID','$Treffer', '$x', '$y', '$Ring', '$Ring01', '$Teiler01', '$TeilerN01') ON DUPLICATE KEY UPDATE x='$x', y='$y', Ring='$Ring', Ring01='$Ring01',Teiler01='$Teiler01', TeilerN01='$TeilerN01'";    
    $db6_query = $dbh6->prepare($inssql);
    $db6_query->execute() or die $db6_query->err_str;
    doLog 9, $inssql;
    ++$NR_Treffer;
  }


    ++$NR;

}
doLog 3, "$NR Scheiben, $NR_Ser Serien, $NR_Treffer Treffer kopiert";
doLog 2, "End copy Scheiben";

$dbh1->disconnect();
$dbh2->disconnect();
$dbh3->disconnect();
$dbh4->disconnect();
$dbh5->disconnect();
$dbh6->disconnect();
