#!/usr/bin/perl -w
use strict;
use lib ".";
use warnings;
use utf8;
use DBI;
use gsConfig;
use gsFunctions;

my ($db1_user, $db1_name, $db1_passwd, $db1_host, $db1_port) = @SSMDB2;
my ($db2_user, $db2_name, $db2_passwd, $db2_host, $db2_port) = @WERTUNGDB;

my $dbh1 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
my $dbh2 = DBI->connect("DBI:mysql:database=$db2_name;host=$db2_host;port=$db2_port", "$db2_user", "$db2_passwd");

my $SqlListe = "";
my @StarterListen = split(";",$STARTERLISTEN);
foreach my $StarterListe ( @StarterListen ) {
  if ( $SqlListe eq "" ) { $SqlListe = "Starterliste='$StarterListe'"; } else {$SqlListe = "$SqlListe OR Starterliste='$StarterListe'"; }
}

my $selsql="select DISTINCT SportpassID, Nachname, Vorname, Klasse, VereinsID, Verein, StarterlistenID, StartNr from Scheiben where $SqlListe ";
my $db1_query = $dbh1->prepare($selsql);
$db1_query->execute() or die $db1_query->err_str;

doLog 2, "Start copy Teilnehmer";
doLog 3, $selsql;

my $inssql;
my $selsql1;
my $selsql2;
my $db2_query;
my $db3_query;
my $RowsInTable;
my $Teilnehmer;
my $Punkte;
my $Prozent;
my $Zeitstempel;
while (my ($SportpassID, $Nachname, $Vorname, $Klasse, $VereinsID, $Verein, $StarterlistenID, $StartNr) = $db1_query->fetchrow_array() ) {
    my $Nummer=$StarterlistenID*$SlMultiplikator+$StartNr;
    $selsql1="select Zeitstempel from Scheiben where SportpassID='$SportpassID' AND StarterlistenID='$StarterlistenID' order by Zeitstempel limit 1";
    $db2_query = $dbh1->prepare($selsql1);
    $db2_query->execute() or die $db2_query->err_str;
    ($Zeitstempel)=$db2_query->fetchrow_array();
    $inssql="INSERT INTO Teilnehmer (SportpassID, Nachname, Vorname, Klasse, VereinsID, Verein, Nummer, ErsteScheibe) VALUES ('$SportpassID', '$Nachname', '$Vorname', '$Klasse', '$VereinsID', '$Verein', '$Nummer', '$Zeitstempel') ON DUPLICATE KEY UPDATE Nachname = '$Nachname', Vorname = '$Vorname', Klasse = '$Klasse', VereinsID='$VereinsID', Verein = '$Verein', Nummer = '$Nummer', ErsteScheibe='$Zeitstempel'";
    $db2_query = $dbh2->prepare($inssql);
    $db2_query->execute() or die $db2_query->err_str;
    doLog 5, $inssql;

}
doLog 2, "End copy Teilnehmer";

doLog 2, "Gen Punkte Vereine";
$selsql1="SELECT VereinsName, Mitglieder from Vereine";
$db1_query = $dbh2->prepare($selsql1);
$db1_query->execute() or die $db1_query->err_str;
doLog 8, $selsql1;
while ( my ($VereinsName, $Mitglieder) = $db1_query->fetchrow_array() ) {
  $Teilnehmer=0;
  $Punkte=0;
  foreach my $TPunkte ( keys %Teilnehmerpunkte ) {
    $selsql2="SELECT count(*) from Teilnehmer where Verein='$VereinsName' AND ErsteScheibe >='$Teilnehmerpunkte{$TPunkte}[0]' AND ErsteScheibe <'$Teilnehmerpunkte{$TPunkte}[1]'";
    $db2_query = $dbh2->prepare($selsql2);
    $db2_query->execute() or die $db2_query->err_str;
    doLog 8, $selsql2;
    $RowsInTable=$db2_query->fetchrow_array();
    $db2_query->finish;
    $Teilnehmer=$Teilnehmer+$RowsInTable;
    $Punkte=$Punkte+$RowsInTable*$TPunkte;
  }
  $Prozent=100*$Teilnehmer/$Mitglieder;
  $inssql="UPDATE Vereine SET Teilnehmer='$Teilnehmer', Punkte='$Punkte', Prozent='$Prozent' where VereinsName='$VereinsName'";
  $db3_query = $dbh2->prepare($inssql);
  $db3_query->execute() or die $db3_query->err_str;
  doLog 7, $inssql;

}

doLog 2, "Gen Jugend Vereine";
$selsql1="SELECT VereinsName from Vereine";
$db1_query = $dbh2->prepare($selsql1);
$db1_query->execute() or die $db1_query->err_str;
doLog 8, $selsql1;
my $jugendstr="";
$jugendstr=get_einst_str("Jugendklassen");
#print "$jugendstr \n";
while ( my ($VereinsName) = $db1_query->fetchrow_array() ) {
  $selsql2="SELECT count(*) from Teilnehmer where Verein='$VereinsName' AND ( $jugendstr )";
  $db2_query = $dbh2->prepare($selsql2);
  $db2_query->execute() or die $db2_query->err_str;
  doLog 8, $selsql2;
  $RowsInTable=$db2_query->fetchrow_array();
  $db2_query->finish;
  $inssql="UPDATE Vereine SET Jugend='$RowsInTable' where VereinsName='$VereinsName'";
  $db3_query = $dbh2->prepare($inssql);
  $db3_query->execute() or die $db3_query->err_str;
  doLog 7, $inssql;

}

$dbh1->disconnect();
$dbh2->disconnect();
