#!/usr/bin/perl -w
use strict;
use lib ".";
use warnings;
use DBI;
use gsConfig;
use gsFunctions;

my ($db1_user, $db1_name, $db1_passwd, $db1_host, $db1_port) = @WERTUNGDB;

my $dbh1 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
my $dbh2 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");


my $inssql;
my $selsql;
my $aktDisziplin;
my $aktStartNr=0;
my $db2_query;
my @Werte=();
my $P=0;
my $NR=0;
my $NR_E=0;
my $RowsInTable=0;
my $aktRow=0;
my $Platz=0;
my ($StartNr, $Disziplin, $Wert1, $Wert2);
doLog 3, "Leere Tabelle TeilerP";
my $db1_query = $dbh1->prepare("TRUNCATE TeilerP");
$db1_query->execute() or die $db1_query->err_str;

my $SqlDisz="";
foreach my $Wertung ( keys %PunktWert ) {
  $SqlDisz="";
  my ($Bezeichnung, $TN, $Disziplinens) = @{$PunktWert{$Wertung}};
  my @Disziplinen = split(";",$Disziplinens);
  foreach my $Disziplin ( @Disziplinen ) {
	if ( $SqlDisz eq "" ) { $SqlDisz = "Disziplin='$Disziplin'"; } else {$SqlDisz = "$SqlDisz OR Disziplin='$Disziplin'"; }
  }
  @Werte=();
  $aktStartNr=0;
  $P=0;
  $NR=0;
  $NR_E=0;
  $aktRow=0;
  doLog 4, "Start generating $Wertung Table";
  $db1_query = $dbh1->prepare("SELECT count(*) from Treffer_view WHERE $SqlDisz");
  $db1_query->execute() or die $db1_query->err_str;
  $RowsInTable=$db1_query->fetchrow_array();
  $selsql="SELECT StartNr, Disziplin, $TN from Treffer_view WHERE $SqlDisz order by StartNr, $TN";
  $db1_query = $dbh1->prepare($selsql);
  $db1_query->execute() or die $db1_query->err_str;
  doLog 8, $selsql;
  while ( ($StartNr, $Disziplin, $Wert1) = $db1_query->fetchrow_array() ) {
    ++$aktRow;
    if ( $aktStartNr == 0 ) { $aktStartNr=$StartNr; }
    if ( $StartNr != $aktStartNr || $aktRow == $RowsInTable ) {
      # Neuer Starter, oder neue Disziplin. Werte schreiben und Arrays initialisieren
      if ($aktRow == $RowsInTable) {
        doLog 8, "Push $TN $Wert1 to Array. StartNr $StartNr, Disziplin $Disziplin, Wertung $Wertung, Row $aktRow of $RowsInTable";
        push @Werte, $Wert1;
      }
      if (scalar @Werte < 10) { for my $i ( scalar @Werte .. 10 ) { push @Werte, $FuellTeiler; } }
      for my $i ( 0 .. $AnzTeilerPraemie -1) { $P = $P + $Werte[$i]; }
      $inssql="INSERT INTO TeilerP (StartNr, Disziplin, Typ, P, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10) VALUES ('$aktStartNr', '$Wertung', '$TN', '$P', '$Werte[0]', '$Werte[1]', '$Werte[2]', '$Werte[3]', '$Werte[4]', '$Werte[5]', '$Werte[6]', '$Werte[7]', '$Werte[8]', '$Werte[9]')  ON DUPLICATE KEY UPDATE Typ='$TN', P='$P', T1='$Werte[0]', T2='$Werte[1]', T3='$Werte[2]', T4='$Werte[3]', T5='$Werte[4]', T6='$Werte[5]', T7='$Werte[6]', T8='$Werte[7]', T9='$Werte[8]', T10='$Werte[9]'";
      $db2_query = $dbh2->prepare($inssql);
      $db2_query->execute() or die $db2_query->err_str;
      doLog 8, $inssql;
      $P=0;
      @Werte=();
      if ($aktRow != $RowsInTable) {
        doLog 8, "Push $TN $Wert1 to Array. StartNr $StartNr, Disziplin $Disziplin, Wertung $Wertung, Row $aktRow of $RowsInTable";
        push @Werte, $Wert1;
      }
      $NR_E=$NR_E+1;
      $NR=$NR+1;
      $aktStartNr=$StartNr;
      $aktDisziplin=$Disziplin;
    } else {
      # Gleicher Starter und Disziplin - Werte in Array
      doLog 8, "Push $TN $Wert1 to Array. StartNr $StartNr, Disziplin $Disziplin, Wertung $Wertung, Row $aktRow of $RowsInTable";
      push @Werte, $Wert1;
      $NR=$NR+1;
    }
  }
  doLog 3, "$NR_E $TN Eintraege aus $NR Scheiben generiert";
  doLog 4, "Finish generating $Wertung Table" ;

  # Platzierung vergeben
  doLog 4, "Start Platzierungen $Wertung Table" ;
  $selsql="SELECT StartNr, Disziplin from TeilerP WHERE Disziplin='$Wertung' order by T1, T2, T3, T4, T5, T6, T7, T8, T9, T10";
  $db1_query = $dbh1->prepare($selsql);
  $db1_query->execute() or die $db1_query->err_str;
  doLog 8, $selsql;
  $Platz=1;
  while ( ($StartNr, $Disziplin) = $db1_query->fetchrow_array() ) {
    $inssql="UPDATE TeilerP SET Platz='$Platz' WHERE  StartNr='$StartNr' AND Disziplin='$Disziplin'";
    $db2_query = $dbh2->prepare($inssql);
    $db2_query->execute() or die $db2_query->err_str;
    doLog 8, $inssql;
    ++$Platz;
  }
  # Praemie Platzierung vergeben
  $selsql="SELECT StartNr, Disziplin from TeilerP WHERE Disziplin='$Wertung' order by P, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10";
  $db1_query = $dbh1->prepare($selsql);
  $db1_query->execute() or die $db1_query->err_str;
  doLog 8, $selsql;
  $Platz=1;
  while ( ($StartNr, $Disziplin) = $db1_query->fetchrow_array() ) {
    $inssql="UPDATE TeilerP SET PlatzP='$Platz' WHERE  StartNr='$StartNr' AND Disziplin='$Disziplin'";
    $db2_query = $dbh2->prepare($inssql);
    $db2_query->execute() or die $db2_query->err_str;
    doLog 8, $inssql;
    ++$Platz;
  }
  doLog 4, "Ende Platzierungen $Wertung Table" ;
}

$dbh1->disconnect();
$dbh2->disconnect();
