#!/usr/bin/perl -w
use strict;
use lib ".";
use warnings;
use DBI;
use gsConfig;
use gsFunctions;

#our ($AnzRingPraemie);
#our (%RingDisziplin);
#our (%Ring01Disziplin);
#our ($FuellRing);
#our (@WERTUNGDB);
#require "config.pl";

my ($db1_user, $db1_name, $db1_passwd, $db1_host, $db1_port) = @WERTUNGDB;

my $dbh1 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
my $dbh2 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");


my $inssql;
my $selsql;
my $aktDisziplin;
my $aktStartNr=0;
my $db2_query;
my @Ringe=();
my $P=0;
my $NR=0;
my $NR_E=0;
my $RowsInTable=0;
my $aktRow=0;
my $Platz=0;
my ($StartNr, $Disziplin, $Serie, $Ring, $Ring01);
doLog 3, "Leere Tabelle SerienP";
my $db1_query = $dbh1->prepare("TRUNCATE SerienP");
$db1_query->execute() or die $db1_query->err_str;

my $SqlDisz="";
foreach my $Wertung ( keys %MeisterWert ) {
  # %MeisterWert sind alle Disziplinen, für die eine Wertung erstellt werden soll
  $SqlDisz="";
  my ($Bezeichnung, $RZ, $Disziplinens) = @{$MeisterWert{$Wertung}};
  my @Disziplinen = split(";",$Disziplinens);
  foreach my $Disziplin ( @Disziplinen ) {
	if ( $SqlDisz eq "" ) { $SqlDisz = "Disziplin='$Disziplin'"; } else {$SqlDisz = "$SqlDisz OR Disziplin='$Disziplin'"; }
  }
  @Ringe=();
  $aktStartNr=0;
  $P=0;
  $NR=0;
  $NR_E=0;
  $aktRow=0;
  doLog 4, "Start generating $Wertung Table";
  $db1_query = $dbh1->prepare("SELECT count(*) from Scheiben inner join Serien on Scheiben.ScheibenID = Serien.ScheibenID WHERE $SqlDisz");
  $db1_query->execute() or die $db1_query->err_str;
  $RowsInTable=$db1_query->fetchrow_array();
  $selsql="SELECT Scheiben.StartNr, Scheiben.Disziplin, Serien.Serie, Serien.Ring, Serien.Ring01 from Scheiben inner join Serien on Scheiben.ScheibenID = Serien.ScheibenID WHERE $SqlDisz order by StartNr, $RZ desc";
  $db1_query = $dbh1->prepare($selsql);
  $db1_query->execute() or die $db1_query->err_str;
  doLog 8, $selsql;
  while ( ($StartNr, $Disziplin, $Serie, $Ring, $Ring01) = $db1_query->fetchrow_array() ) {
    ++$aktRow;
    if ( $RZ eq "Ring01" ) { $Ring = $Ring01; } 
    if ( $aktStartNr == 0 ) { $aktStartNr=$StartNr; }
    if ( $StartNr != $aktStartNr || $aktRow == $RowsInTable ) {
      # Neuer Starter, oder neue Disziplin. Werte schreiben und Arrays initialisieren
      if ($aktRow == $RowsInTable) {
        doLog 8, "Push $RZ $Ring to Array. StartNr $StartNr, Disziplin $Disziplin, Wertung $Wertung, Row $aktRow of $RowsInTable -RT EQ";
        push @Ringe, $Ring;
        $NR=$NR+1;
      }
      if (scalar @Ringe < 10) { for my $i ( scalar @Ringe .. 10 ) { push @Ringe, 0; } }
      for my $i ( 0 .. $AnzRingPraemie -1) { $P = $P + $Ringe[$i]; }
      $inssql="INSERT INTO SerienP (StartNr, Disziplin, Typ, P, S1, S2, S3, S4, S5, S6, S7, S8, S9, S10) VALUES ('$aktStartNr', '$Wertung', '$RZ', '$P', '$Ringe[0]', '$Ringe[1]', '$Ringe[2]', '$Ringe[3]', '$Ringe[4]', '$Ringe[5]', '$Ringe[6]', '$Ringe[7]', '$Ringe[8]', '$Ringe[9]')  ON DUPLICATE KEY UPDATE P='$P', S1='$Ringe[0]', S2='$Ringe[1]', S3='$Ringe[2]', S4='$Ringe[3]', S5='$Ringe[4]', S6='$Ringe[5]', S7='$Ringe[6]', S8='$Ringe[7]', S9='$Ringe[8]', S10='$Ringe[9]'";

      $db2_query = $dbh2->prepare($inssql);
      $db2_query->execute() or die $db2_query->err_str;
      doLog 8, $inssql;
      $P=0;
      @Ringe=();
      if ($aktRow != $RowsInTable) {
        doLog 8, "Push $RZ $Ring to Array. StartNr $StartNr, Disziplin $Disziplin, Wertung $Wertung, Row $aktRow of $RowsInTable - RT";
        push @Ringe, $Ring;
      }
      $NR_E=$NR_E+1;
      $NR=$NR+1;
      $aktStartNr=$StartNr;
      $aktDisziplin=$Disziplin;
    } else {
      # Gleicher Starter und Disziplin - Werte in Array
       doLog 8, "Push $RZ $Ring to Array. StartNr $StartNr, Disziplin $Disziplin, Wertung $Wertung, Row $aktRow of $RowsInTable - GS";
       push @Ringe, $Ring;
      $NR=$NR+1;
    }
  }
  doLog 3, "$NR_E $RZ Eintraege aus $NR Scheiben generiert";
  doLog 4, "Finish generating $Wertung Table" ;

  # Platzierung vergeben
  doLog 4, "Start Platzierungen $Wertung Table" ;
  $selsql="SELECT StartNr, Disziplin from SerienP WHERE Disziplin='$Wertung' order by S1 desc, S2 desc, S3 desc, S4 desc, S5 desc, S6 desc, S7 desc, S8 desc, S9 desc, S10 desc";
  $db1_query = $dbh1->prepare($selsql);
  $db1_query->execute() or die $db1_query->err_str;
  doLog 8, $selsql;
  $Platz=1;
  while ( ($StartNr, $Disziplin) = $db1_query->fetchrow_array() ) {
    $inssql="UPDATE SerienP SET Platz='$Platz' WHERE  StartNr='$StartNr' AND Disziplin='$Disziplin'";
    $db2_query = $dbh2->prepare($inssql);
    $db2_query->execute() or die $db2_query->err_str;
    doLog 8, $inssql;
    ++$Platz;
  }
  $selsql="SELECT StartNr, Disziplin from SerienP WHERE Disziplin='$Wertung' order by P desc, S1 desc, S2 desc, S3 desc, S4 desc, S5 desc, S6 desc, S7 desc, S8 desc, S9 desc, S10 desc";
  $db1_query = $dbh1->prepare($selsql);
  $db1_query->execute() or die $db1_query->err_str;
  doLog 8, $selsql;
  $Platz=1;
  while ( ($StartNr, $Disziplin) = $db1_query->fetchrow_array() ) {
    $inssql="UPDATE SerienP SET PlatzP='$Platz' WHERE  StartNr='$StartNr' AND Disziplin='$Disziplin'";
    $db2_query = $dbh2->prepare($inssql);
    $db2_query->execute() or die $db2_query->err_str;
    doLog 8, $inssql;
    ++$Platz;
  }
  doLog 4, "Ende Platzierungen $Wertung Table" ;
} 

$dbh1->disconnect();
$dbh2->disconnect();
