#!/usr/bin/perl -w
use strict;
use lib ".";
use warnings;
use utf8;
use Net::Ping;
use DBI;
use gsConfig;
use gsFunctions;

my ($db1_user, $db1_name, $db1_passwd, $db1_host, $db1_port) = @SSMDB2;
my ($db2_user, $db2_name, $db2_passwd, $db2_host, $db2_port) = @WERTUNGDB;

my $p = Net::Ping->new();

my $pstatus;
if ( system("ping -c 2 $db1_host >/dev/null 2>&1") == 0 ) {
    $pstatus="ok";
}
else {
    $pstatus="fail";
    print "ping $db1_host fail!\n";
}

if ( system("ping -c 2 $db2_host >/dev/null 2>&1") == 0 ) {
	#$status="ok";
}
else {
    $pstatus="fail";
    print "ping $db2_host fail!\n";
}

if ($pstatus eq "ok") {
	my $dbh1 = DBI->connect("DBI:mysql:database=$db1_name;host=$db1_host;port=$db1_port", "$db1_user", "$db1_passwd");
	my $dbh2 = DBI->connect("DBI:mysql:database=$db2_name;host=$db2_host;port=$db2_port", "$db2_user", "$db2_passwd");
	my $selsql="select Zeitstempel from Scheiben order by Zeitstempel desc limit 1";
	my $db1_query = $dbh1->prepare($selsql);
	$db1_query->execute() or die $db1_query->err_str;
	my $db2_query = $dbh2->prepare($selsql);
	$db2_query->execute() or die $db2_query->err_str;
	my ($Zeitstempel1)=$db1_query->fetchrow_array();
	my ($Zeitstempel2)=$db2_query->fetchrow_array();
	doLog 3, "Zeitstempelvergleich $Zeitstempel1 - $Zeitstempel2";
	if ($Zeitstempel1 ne $Zeitstempel2) {
		# Exitcode 0 - Starte abgleich
		exit 0;
	}
}
exit 1;
